Package org.apache.tools.ant.types.resources

# Class ResourceDecorator

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.ResourceDecorator

All Implemented Interfaces:
  `java.lang.Cloneable`, `java.lang.Comparable<Resource>`, `java.lang.Iterable<Resource>`, `ResourceCollection`

Direct Known Subclasses:
  `ContentTransformingResource`, `MappedResource`

    public abstract class ResourceDecorator
    extends Resource

Abstract class that delegates all reading methods of Resource to its wrapped resource and deals with reference handling.

Overwrites all setters to throw exceptions.

Since:
  Ant 1.8.0

- ## Field Summary

  ### Fields inherited from class org.apache.tools.ant.types.Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`

  ### Fields inherited from class org.apache.tools.ant.types.DataType

  `checked, ref`

  ### Fields inherited from class org.apache.tools.ant.ProjectComponent

  `description, location, project`

- ## Constructor Summary

  Constructors
  Modifier | Constructor | Description
  --- | --- | ---
  `protected` | `ResourceDecorator()` | no arg constructor
  `protected` | `ResourceDecorator​(ResourceCollection other)` | Constructor with another resource to wrap.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `addConfigured​(ResourceCollection a)` | Sets the resource to wrap using a single-element collection.
  `<T> T` | `as​(java.lang.Class<T> clazz)` | Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `int` | `compareTo​(Resource other)` | Delegates to a comparison of names.
  `protected void` | `dieOnCircularReference​(java.util.Stack<java.lang.Object> stack, Project project)` | Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `java.io.InputStream` | `getInputStream()` | Get an InputStream for the Resource.
  `long` | `getLastModified()` | Tells the modification time in milliseconds since 01.01.1970 .
  `java.lang.String` | `getName()` | Get the name of the resource.
  `java.io.OutputStream` | `getOutputStream()` | Get an OutputStream for the Resource.
  `protected Resource` | `getResource()` | De-references refids if any, ensures a wrapped resource has been specified.
  `long` | `getSize()` | Get the size of this Resource.
  `int` | `hashCode()` | Get the hash code for this Resource.
  `boolean` | `isDirectory()` | Tells if the resource is a directory.
  `boolean` | `isExists()` | The exists attribute tells whether a file exists.
  `boolean` | `isFilesystemOnly()` | Fulfill the ResourceCollection contract.
  `void` | `setDirectory​(boolean directory)` | Override setDirectory.
  `void` | `setExists​(boolean exists)` | Set the exists attribute.
  `void` | `setLastModified​(long lastmodified)` | Override setLastModified.
  `void` | `setName​(java.lang.String name)` | Overridden, not allowed to set the name of the resource.
  `void` | `setRefid​(Reference r)` | Overrides the base version.
  `void` | `setSize​(long size)` | Override setSize.

  ### Methods inherited from class org.apache.tools.ant.types.Resource

  `asOptional, clone, equals, getMagicNumber, getRef, iterator, size, toLongString, toString`

  ### Methods inherited from class org.apache.tools.ant.types.DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`

  ### Methods inherited from class org.apache.tools.ant.ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

  ### Methods inherited from interface org.apache.tools.ant.types.ResourceCollection

  `isEmpty, stream`

- ## Constructor Details

  - ### ResourceDecorator

    protected ResourceDecorator()
    no arg constructor

  - ### ResourceDecorator

    protected ResourceDecorator​(ResourceCollection other)
    Constructor with another resource to wrap.
    Parameters:
      `other` - the resource to wrap.

- ## Method Details

  - ### addConfigured

    public final void addConfigured​(ResourceCollection a)
    Sets the resource to wrap using a single-element collection.
    Parameters:
      `a` - the resource to wrap as a single element Resource collection.

  - ### getName

    public java.lang.String getName()
    Get the name of the resource.
    Overrides:
      `getName` in class `Resource`
    Returns:
      the name of the wrapped resource.

  - ### isExists

    public boolean isExists()
    The exists attribute tells whether a file exists.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if this resource exists.

  - ### getLastModified

    public long getLastModified()
    Tells the modification time in milliseconds since 01.01.1970 .
    Overrides:
      `getLastModified` in class `Resource`
    Returns:
      0 if the resource does not exist to mirror the behavior of `File`.

  - ### isDirectory

    public boolean isDirectory()
    Tells if the resource is a directory.
    Overrides:
      `isDirectory` in class `Resource`
    Returns:
      boolean flag indicating if the resource is a directory.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the size, as a long, 0 if the Resource does not exist (for compatibility with java.io.File), or UNKNOWN_SIZE if not known.

  - ### getInputStream

    public java.io.InputStream getInputStream() throws java.io.IOException
    Get an InputStream for the Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream containing this Resource's content.
    Throws:
      `java.io.IOException` - if unable to provide the content of this Resource as a stream.
      `java.lang.UnsupportedOperationException` - if InputStreams are not supported for this Resource type.

  - ### getOutputStream

    public java.io.OutputStream getOutputStream() throws java.io.IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `java.io.IOException` - if unable to provide the content of this Resource as a stream.
      `java.lang.UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.

  - ### isFilesystemOnly

    public boolean isFilesystemOnly()
    Fulfill the ResourceCollection contract.
    Specified by:
      `isFilesystemOnly` in interface `ResourceCollection`
    Overrides:
      `isFilesystemOnly` in class `Resource`
    Returns:
      whether this Resource is a FileProvider.

  - ### setRefid

    public void setRefid​(Reference r)
    Overrides the base version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### as

    public <T> T as​(java.lang.Class<T> clazz)
    Returns a view of this resource that implements the interface given as the argument or null if there is no such view.

    This allows extension interfaces to be added to resources without growing the number of permutations of interfaces decorators/adapters need to implement.

    This implementation of the method will return the current instance itself if it can be assigned to the given class.

    Overrides:
      `as` in class `Resource`
    Type Parameters:
      `T` - desired type
    Parameters:
      `clazz` - a class
    Returns:
      resource of a desired type

  - ### compareTo

    public int compareTo​(Resource other)
    Delegates to a comparison of names.
    Specified by:
      `compareTo` in interface `java.lang.Comparable<Resource>`
    Overrides:
      `compareTo` in class `Resource`
    Parameters:
      `other` - the object to compare to.
    Returns:
      a negative integer, zero, or a positive integer as this Resource is less than, equal to, or greater than the specified Resource.

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### getResource

    protected final Resource getResource()
    De-references refids if any, ensures a wrapped resource has been specified.
    Returns:
      Resource

  - ### dieOnCircularReference

    protected void dieOnCircularReference​(java.util.Stack<java.lang.Object> stack, Project project) throws BuildException
    Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    If one is included, throw a BuildException created by `circularReference`.

    This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

    The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stack` - the stack of references to check.
      `project` - the project to use to dereference the references.
    Throws:
      `BuildException` - on error.

  - ### setName

    public void setName​(java.lang.String name) throws BuildException
    Overridden, not allowed to set the name of the resource.
    Overrides:
      `setName` in class `Resource`
    Parameters:
      `name` - not used.
    Throws:
      `BuildException` - always.

  - ### setExists

    public void setExists​(boolean exists)
    Set the exists attribute.
    Overrides:
      `setExists` in class `Resource`
    Parameters:
      `exists` - if true, this resource exists.

  - ### setLastModified

    public void setLastModified​(long lastmodified) throws BuildException
    Override setLastModified.
    Overrides:
      `setLastModified` in class `Resource`
    Parameters:
      `lastmodified` - not used.
    Throws:
      `BuildException` - always.

  - ### setDirectory

    public void setDirectory​(boolean directory) throws BuildException
    Override setDirectory.
    Overrides:
      `setDirectory` in class `Resource`
    Parameters:
      `directory` - not used.
    Throws:
      `BuildException` - always.

  - ### setSize

    public void setSize​(long size) throws BuildException
    Override setSize.
    Overrides:
      `setSize` in class `Resource`
    Parameters:
      `size` - not used.
    Throws:
      `BuildException` - always.